import { Injectable } from "@nestjs/common";
import { DbService } from "apps/backend/src/app/db/db.service";
import { FilesGroupTable } from "apps/backend/src/app/db/schema";
import { ilike } from "drizzle-orm";

@Injectable()
export class GroupsService {
	constructor(private readonly database: DbService) {}

	//TODO a method to fetch groups in the database by a specific search with limit, offset and a search field (can be blank)
	async getGroupsByName(limit: number, offset: number, search: string) {
		return await this.database
			.use()
			.select()
			.from(FilesGroupTable)
			.where(ilike(FilesGroupTable.groupName, search))
			.limit(limit)
			.offset(offset)
			.prepare("getGroupsByName")
			.execute();
	}

	//TODO The method to create a group
	async newGroup(groupName: string) {
		return await this.database
			.use()
			.insert(FilesGroupTable)
			.values({
				groupName: groupName,
			})
			.returning()
			.prepare("newGroup")
			.execute();
	}

	//TODO a method to delete a group and place the associated file at a null group reference
	async deleteGroup(groupId: string) {}

	//TODO a method to get the files of a group in the database by a specific search with limit, offset and a search field (can be blank)
	async findFilesForGroup(
		limit: number,
		offset: number,
		searchField: string,
		groupId: string,
	) {}
}
